package com.changhong.epc.demo;

import com.iemsoft.framework.cloud.core.tools.AbstractSelectCrosswise;

import java.util.HashMap;
import java.util.Map;
import java.util.Objects;


public class MvList extends AbstractSelectCrosswise<Map<String, Object>, Map<String, Object>> {

	private static final String ROW_NO = "rowNo";
	
	@Override
	protected boolean isOneRow(Map<String, Object> last, Map<String, Object> thisObj) {
		return Objects.equals(last.get(ROW_NO), thisObj.get(ROW_NO));
	}

	@Override
	protected Map<String, Object> newInstanceR() {
		return new HashMap<>();
	}

	@Override
	protected void addRowData(Map<String, Object> row, Map<String, Object> obj) {
		row.put(Objects.toString(obj.get("eleCode")), obj.get("eleValue"));
	}

}
