package com.changhong.epc.demo;

import com.changhong.epc.constter.system.SystemClients;
import com.changhong.epc.constter.system.run.EpcApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.autoconfigure.jdbc.DataSourceAutoConfiguration;
import org.springframework.cloud.netflix.archaius.ArchaiusAutoConfiguration;
import org.springframework.context.annotation.ComponentScan;

@SpringBootApplication(exclude = {
        DataSourceAutoConfiguration.class,ArchaiusAutoConfiguration.class
})
//@SpringCloudApplication
@ComponentScan(basePackages={"com.changhong.epc","com.iemsoft.framework.cloud"})
public class DemoApplication implements SystemClients{
	
	public static void main(String[] args) throws Exception {
		new EpcApplication(SERVER_DEMO, DemoApplication.class).run(args);
//		ResMsg<TenantInfo> resMsg = JSON.parseObject("", new TypeReference<ResMsg<TenantInfo>>(){});

	}
}
