package com.changhong.epc.demo.service.tenant.log.impl;

import com.changhong.epc.bean.tenant.log.ProcessLog;
import com.changhong.epc.demo.mapper.tenant.log.ProcessLogMapper;
import com.changhong.epc.demo.service.tenant.log.ProessLogService;
import com.codingapi.tx.annotation.TxTransaction;
import com.iemsoft.framework.cloud.redis.annotation.CacheRm;
import com.iemsoft.framework.cloud.redis.annotation.CacheSave;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.List;

@Service("proessLogService")
public class ProessLogServiceImpl implements ProessLogService {

	@Resource
	private ProcessLogMapper processLogMapper;
	
	@Override
	@CacheSave
	public List<ProcessLog> processPage(ProcessLog processLog) {
		return processLogMapper.selectPage(processLog);
//		return processLogMapper.selectAll();
	}
	
	@CacheRm
	public void updateProcess(){
		
	}

	@Override
	@TxTransaction
	@Transactional
	public void save() {
		ProcessLog t = new ProcessLog();
		t.setActivityInstId(1L);
		t.setActivityDefId("defId");
		t.setActivityDefName("defName");
		processLogMapper.insert(t);
	}

}
